<!doctype html>

<html lang="en">

  <head>

{% include config['templates']['head'] %}

    <link rel="stylesheet" href="css/upcoming_assemblies.css">

    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/jq-3.3.1/jszip-2.5.0/dt-1.10.24/b-1.7.0/b-colvis-1.7.0/b-html5-1.7.0/b-print-1.7.0/cr-1.5.3/date-1.0.3/fh-3.1.8/sb-1.0.1/sp-1.2.2/datatables.min.css"/>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/v/dt/jq-3.3.1/jszip-2.5.0/dt-1.10.24/b-1.7.0/b-colvis-1.7.0/b-html5-1.7.0/b-print-1.7.0/cr-1.5.3/date-1.0.3/fh-3.1.8/sb-1.0.1/sp-1.2.2/datatables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/plug-ins/1.10.25/sorting/absolute.js"></script>
    <script src="https://kit.fontawesome.com/c01ec6dded.js" crossorigin="anonymous"></script>

    <script type="text/javascript">

      $(document).ready(function() {

        var sequencing_status = [
          {% for field in projects_fields %}'{{ field }}',
          {% endfor %}]

        fetch('{{ goat_api_query }}')
          .then(response => response.json())
          .then(response => response.results)
          .then(response => {
            api_data = []
            for (var species in response) {
              taxid = response[species].result.taxon_id
              tmp = [`<a href="{{goat_species_url}}" target="_blank" rel="noopener noreferrer"> ${taxid} </a>`,
                     response[species].result.scientific_name,
                     ]
              for (var status of sequencing_status) {
                tmp2 = status in response[species].result.fields ? response[species].result.fields[status].value : 'NA'
                tmp.push(tmp2)
              }
              api_data.push(tmp)
            }

            // Add column filtering
            $('#assembly_status_table thead tr').clone(true).appendTo('#assembly_status_table thead');
            $('#assembly_status_table thead tr:eq(1) th').each(function (i) {
                $(this).addClass("column-filter-box");
                $(this).html('<input type="text" placeholder="Filter column" />');
                $('input', this).on('change', function () {
                  if (table.column(i).search() !== this.value) {
                    table.column(i).search(this.value).draw();
                  }
                });
            });

            // Override sorting function for numbers mixed with NA to keep NA < 0
            $.fn.dataTable.ext.type.order["html-num-fmt-pre"] = function(data) {
                // Strip HTML
                data = data.replace(/<.*?>/g, '');
                // Remove dots
                data = data.replace(/\./g, '');
                // Replace commas dots
                data = data.replace(/,/g, '.');
                // Strip any remaining no numeric data
                data = data.replace(/[^0-9\.\-]/g, '');
                if ( data === '' ) { // it was NA
                  return -Infinity;
                }
                return data*1;
            };

            var table = $('#assembly_status_table').DataTable({

              dom: 'frBtip',
              colReorder: true,
              orderCellsTop: true,
              fixedHeader: true,
              info: true,
              processing: true,
              scrollX: true,
              pageLength: 25,
              pagingType: "full_numbers",
              deferRender: true,
              orderClasses: false,

              columnDefs: [
                {
                  targets: "_all",
                  className: "dt-body-left",
                  createdCell: function (td, cellData, rowData, row, col) {
                    if (cellData == 'NA') {
                      $(td).css('color', '#b3b3b3')
                      $(td).css('font-style', 'italic')
                    }
                  }
                }
              ],

              buttons: [
                {
                  extend: 'copy',
                  text: '<i class="fa fa-copy"></i>',
                  titleAttr: 'Copy current table to clipboard',
                  exportOptions: {
                    columns: ':visible'
                  }
                },
                {
                  extend: 'excel',
                  text: '<i class="fa fa-file-excel"></i>',
                  titleAttr: 'Export current table to excel spreadsheet',
                  exportOptions: {
                    columns: ':visible'
                  }
                },
                {
                  extend: 'csv',
                  text: '<i class="fa fa-file-csv"></i>',
                  titleAttr: 'Export current table to CSV',
                  exportOptions: {
                    columns: ':visible'
                  }
                },
                {
                  extend: 'searchBuilder',
                  text: '<i class="fas fa-filter"></i>',
                  titleAttr: 'Advanced filtering',
                  config: {
                    depthLimit: 2
                  }
                },
              ],

              language: {
                search: '<i class="fa fa-search" style="font-size: 1.25em;"></i>',
                searchPlaceholder: 'Search anything...',
                searchBuilder: {
                  add: '+',
                  clearAll: '<i class="fas fa-trash"></i>',
                  logicAnd: 'AND',
                  valueJoiner: 'AND',
                  logicOr: 'OR',
                  button: {
                    0: '<i class="fas fa-filter"></i>',
                    _: '<i class="fas fa-filter"></i> (%d)'
                  },
                  title: {
                    0: 'Filters',
                    _: 'Filters (%d)'
                  }
                }
              },

              searchBuilder: {},

              data: api_data

            });

          var table_div = document.getElementById("table_header")
          table_div.style.opacity = 1;
          var loading_div = document.getElementById("loading-info")
          loading_div.style.display = "none";

          });

        });

      $.fn.DataTable.ext.pager.numbers_length = 3;

    </script>

  </head>

{% include config['templates']['header'] %}

  <main>

    <div class="upcoming-assemblies-info">
      <p>The table below summarizes ongoing sequencing efforts for Arthropods. The data are obtained from <a href="https://goat.genomehubs.org/" target="_blank" rel="noopener noreferrer">Genomes on a Tree</a> (GoaT), a resource that compiles information from major sequencing projects. The table includes all species covered by at least one sequencing project included in GoaT, with a link to the relevant GoaT record.</p>
    </div>

    <div id="loading-info" style="font-size: 20px; margin-top: 40px;">Loading data from GoaT ... </div>

    <table id="assembly_status_table" class="stripe hover order-column row-border nowrap compact">

      <thead id="table_header" style="opacity: 0">
        <tr>
          <th>Taxid</th>
          <th>Species</th>
          {% for project in projects_names %}
            <th> {{ project }} </th>
          {% endfor %}
        </tr>
      </thead>

    </table>

  </main>

{% include config['templates']['footer'] %}

</html>
